#### Linux From Scratch - Version 12.0-rc1

### Chapter 8. Installing Basic System Software

- Prev

  OpenSSL-3.1.2

- Next

  Libelf from Elfutils-0.189

- Up
- Home

# 8.48. Kmod-30

The Kmod package contains libraries and utilities for loading kernel modules

Approximate build time: less than 0.1 SBU
Required disk space: 12 MB

## 8.48.1. Installation of Kmod

Prepare Kmod for compilation:

    ./configure --prefix=/usr          \
                --sysconfdir=/etc      \
                --with-openssl         \
                --with-xz              \
                --with-zstd            \
                --with-zlib

The meaning of the configure options:

`--with-openssl`

  This option enables Kmod to handle PKCS7 signatures for kernel modules.

`--with-xz`, `--with-zlib`, and `--with-zstd`

  These options enable Kmod to handle compressed kernel modules.

Compile the package:

    make

The test suite of this package requires raw kernel headers (not the “sanitized” kernel headers installed earlier), which are beyond the scope of LFS.

Install the package and create symlinks for compatibility with Module-Init-Tools (the package that previously handled Linux kernel modules):

    make install

    for target in depmod insmod modinfo modprobe rmmod; do
      ln -sfv ../bin/kmod /usr/sbin/$target
    done

    ln -sfv kmod /usr/bin/lsmod

## 8.48.2. Contents of Kmod

Installed programs: depmod (link to kmod), insmod (link to kmod), kmod, lsmod (link to kmod), modinfo (link to kmod), modprobe (link to kmod), and rmmod (link to kmod)
Installed library: libkmod.so

### Short Descriptions

depmod | Creates a dependency file based on the symbols it finds in the existing set of modules; this dependency file is used by modprobe to automatically load the required modules
insmod | Installs a loadable module in the running kernel
kmod | Loads and unloads kernel modules
lsmod | Lists currently loaded modules
modinfo | Examines an object file associated with a kernel module and displays any information that it can glean
modprobe | Uses a dependency file, created by depmod, to automatically load relevant modules
rmmod | Unloads modules from the running kernel
`libkmod` | This library is used by other programs to load and unload kernel modules

- Prev

  OpenSSL-3.1.2

- Next

  Libelf from Elfutils-0.189

- Up
- Home